/**
 * Copyright (c) 2009 Symantec
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the 'Software'), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *  
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *  
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package com.symantec.premiumServices.asyncThreading.events {
	
	import com.symantec.premiumServices.asyncThreading.interfaces.IAsyncThreadMessage;
	import com.symantec.premiumServices.asyncThreading.interfaces.IAsyncThreadResponder;
	import com.symantec.premiumServices.asyncThreading.interfaces.IFPSObserver;
	
	import flash.events.Event;

	/**
	 * Dispatched by the AsyncThreadingManager class.
	 *  
	 * @author ben rimbey -> ben_rimbey@symantec.com, ben.rimbey@gmail.com 
	 * 
	 */
	public class AsyncThreadManagerEvent extends Event {
		
		/**
		 * constant event type. dispatched when a thread object requests to send a message. 
		 */
		public static const SEND_THREAD_MESSAGE:String = "sendThreadMessage";
		
		/**
		 * the message that was assigned to this event, if applicable. 
		 * 
		 * @see IAsyncThreadMessage
		 */
		public var message:IAsyncThreadMessage;
		
		/**
		 * Constructor. 
		 * @param type
		 * 
		 */
		public function AsyncThreadManagerEvent(type:String) {
			super(type, true, false);
		}
		
	}
}