/**
 * Copyright (c) 2009 Symantec
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the 'Software'), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *  
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *  
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package com.symantec.premiumServices.asyncThreading.vo {
	
	import com.symantec.premiumServices.asyncThreading.interfaces.IAsyncThreadMessage;

	/**
	 * Generic class that implements the <code>IAsyncThreadMessage</code> interface.
	 *  
	 * author ben rimbey -> ben_rimbey@symantec.com, ben.rimbey@gmail.com 
	 * 
	 */
	public class AsyncThreadMessage implements IAsyncThreadMessage {
		
		private var _name:String;
		private var _body:Object;
		
		/**
		 * retrieves the name of the message that is being transported.
		 * 
		 * @return String 
		 * 
		 */
		public function get name():String {
			return _name;
		}
		
		/**
		 * sets the name of the message that is being transported.
		 * 
		 * @param val
		 * 
		 */
		public function set name(val:String):void {
			_name = val;
		}
		
		/**
		 * an untyped reference to the data that is being transported on the message.
		 * 
		 * @return Object 
		 * 
		 */
		public function get body():Object {
			return _body;
		}
		
		/**
		 * sets the data that is being transported on the message.
		 *  
		 * @param val
		 * 
		 */
		public function set body(val:Object):void {
			_body = val;
		}
		
	}
}