package net.onthewings.pv3d
{
	import com.symantec.premiumServices.asyncThreading.abstract.AbstractAsyncThread;
	import com.symantec.premiumServices.asyncThreading.events.AsyncThreadEvent;
	import com.symantec.premiumServices.asyncThreading.interfaces.IAsyncThreadScalableResponder;
	
	import org.papervision3d.core.render.command.RenderableListItem;
	import org.papervision3d.core.render.data.RenderSessionData;
	import org.papervision3d.render.LazyRenderEngine;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.view.layer.ViewportLayer;
	
	public class AsyncBasicRenderEngineDoRenderThread extends AbstractAsyncThread implements IAsyncThreadScalableResponder
	{
		private var renderList:Array;
		private var renderSessionData:RenderSessionData;
		private var callback:Function;
		
		private var numItemPerExecution:uint = 1000;
		private var numItemPerStep:uint = 50;
		
		public function AsyncBasicRenderEngineDoRenderThread(renderList:Array,renderSessionData:RenderSessionData,callback:Function):void {
			this.renderList = renderList;
			this.renderSessionData = renderSessionData;
			this.callback = callback;
			
			this.priority = RUN_LEVEL_REAL_TIME;
			this.addEventListener(AsyncThreadEvent.KILL,cleanUp,false,-100,true);
		}
		
		protected function cleanUp(evt:AsyncThreadEvent = null):void {
			this.renderList = null;
			this.renderSessionData = null;
			this.callback = null;
		}
		
		public function increaseWorkLoad():void {
			numItemPerExecution += numItemPerStep;
		}

		public function decreaseWorkLoad():void {
			if (numItemPerExecution > numItemPerStep) {
				numItemPerExecution -= numItemPerStep;
			} else if (numItemPerExecution > numItemPerStep*0.1) {
				numItemPerExecution -= numItemPerStep*0.1;
			}
		}
		public function execute():void {
			var rc:RenderableListItem;
			var viewport:Viewport3D = renderSessionData.viewPort;
			var vpl:ViewportLayer;
			var count:uint = numItemPerExecution;

			while(count > 0 && renderList.length > 0)
			{
				rc = renderList.pop();
				vpl = viewport.accessLayerFor(rc, true);
				rc.render(renderSessionData, vpl.graphicsChannel);
				viewport.lastRenderList.push(rc);
				vpl.processRenderItem(rc);
				--count;
			}
			
			if (renderList.length <= 0) { //all are rendered
				callback();
			}
		}

	}
}